package a.b.c;

import android.app.Activity;
import android.content.ContentResolver;
import android.content.ContentValues;
import android.content.CursorLoader;
import android.content.Loader;
import android.content.Loader.OnLoadCompleteListener;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;


public class MainActivity extends Activity {

  ContentValues values = null;
  ContentResolver resolver = null;
  CursorLoader loader = null;

  Button button, button2, button3, button4;
  TextView textView;

  Uri CONTENT_URI = Uri.parse
     ("content://com.allmycode.db/names_amounts");
  Uri SILLY_URI = Uri.parse
     ("content://com.allmycode.db/silly_stuff");

  @Override
  public void onCreate(Bundle b) {
    super.onCreate(b);
    setContentView(R.layout.activity_main);

    values = new ContentValues();
    resolver = getContentResolver();

    textView = (TextView) findViewById(R.id.textView);
    button = (Button) findViewById(R.id.button);
    button2 = (Button) findViewById(R.id.button2);
    button3 = (Button) findViewById(R.id.button3);
    button4 = (Button) findViewById(R.id.button4);
  }

  public void onButtonClick(View view) {

    if (view == button) {

      resolver.delete(CONTENT_URI, "1", null);
      showStuffFrom(CONTENT_URI);

    } else if (view == button2) {

      values.clear();
      values.put("name", "Sam");
      values.put("amount", "100");
      resolver.insert(CONTENT_URI, values);
      values.clear();
      values.put("name", "Jennie");
      values.put("amount", "300");
      resolver.insert(CONTENT_URI, values);
      showStuffFrom(CONTENT_URI);

    } else if (view == button3) {

      values.clear();
      values.put("amount", "500");
      resolver.update(CONTENT_URI, values,
         "name='Sam'", null);
      showStuffFrom(CONTENT_URI);

    } else if (view == button4) {

      showStuffFrom(SILLY_URI);

    }
  }

  void showStuffFrom(Uri uri) {
    loader =
       new CursorLoader(this, uri, null, "1", null, null);
    loader.registerListener(42,
       new MyOnLoadCompleteListener());
    loader.startLoading();
  }

  class MyOnLoadCompleteListener implements
     OnLoadCompleteListener<Cursor> {

    @Override
    public void onLoadComplete(Loader<Cursor> loader,
                               Cursor cursor) {
      textView.setText("");
      if (cursor != null && cursor.moveToFirst()) {
        do {
          String _id = cursor.getString(0);
          String name = cursor.getString(1);
          int amount = cursor.getInt(2);
          textView.append(_id + " " + name + " " + amount
             + "\n");
        } while (cursor.moveToNext());
      }
    }
  }
}
